"{ Package: 'stx:goodies/petitparser/compiler/tests' }"

"{ NameSpace: Smalltalk }"

TestCase subclass:#PPCOptimizeChoicesTest
	instanceVariableNames:'node result visitor configuration'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Tests-Visitors'
!

!PPCOptimizeChoicesTest methodsFor:'as yet unclassified'!

asPPCTree: parser
    ^ parser compileWithConfiguration: configuration
!

setUp
    | options |
    super setUp.

    visitor := PPCOptimizeChoices new.
    
    options := PPCCompilationOptions default
                    profile: true;
                    generate: false;
                    tokenize: false;
                    yourself.
                
    configuration := PPCConfiguration new.
    configuration passes: 
                        {
                            PPCCacheFirstFollowPass.
                        }.
    configuration options: options.

    "Modified: / 04-09-2015 / 16:21:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

testHasCommonPrefix
    | foo bar |
    foo := 'foo' asParser name: 'foo'; yourself.
    bar := 'bar' asParser.
    
    node := self asPPCTree: (foo, bar) / foo.

    self assert: (visitor hasCommonPrefix: node children).
! !

